#extension GL_OES_EGL_image_external : require
#ifdef EXTERNAL_MASK
uniform samplerExternalOES mask_texture;
#else
uniform sampler2D mask_texture; // the mask texture object
#endif
uniform sampler2D shape_texture; // the shape texture object

varying highp vec2 v_brushTextureCoordinate; // texture coordinates
varying highp vec2 v_canvasTextureCoordinate; // texture coordinates

uniform highp vec4 brush_color;

uniform highp float pressure;

#ifdef USES_TEXTURE
uniform sampler2D texture_texture; // the texture texture object
varying highp vec2 v_textureTextureCoordinate; // texture coordinates
#endif

void main() {
    highp vec4 maskTexelColor = texture2D(mask_texture, v_canvasTextureCoordinate);
    highp vec4 shapeTexelColor = texture2D(shape_texture, v_brushTextureCoordinate);
    highp float alpha =  maskTexelColor.a * pressure;

#ifdef USES_TEXTURE

    highp vec4 textureTexelColor = texture2D(texture_texture, v_textureTextureCoordinate);

    gl_FragColor = brush_color * shapeTexelColor * alpha * textureTexelColor;

#else

    gl_FragColor = brush_color * shapeTexelColor * alpha;

#endif


}
