#version 300 es

in vec2 v_BrushTextureCoordinate;
in vec2 v_MaskTextureCoordinate;

layout(location = 2) uniform sampler2D u_MaskTexture;
layout(location = 3) uniform sampler2D u_BrushTexture;
layout(location = 4) uniform highp vec4 u_Color;
layout(location = 5) uniform highp float u_Pressure;

#ifdef USES_TEXTURE
in vec2 v_CanvasTextureCoordinate;
layout(location = 6) uniform sampler2D u_CanvasTexture;
#endif

out vec4 fragmentColor;

void main() {
  highp vec4 maskTexelColor = texture(u_MaskTexture, v_MaskTextureCoordinate);
  highp vec4 shapeTexelColor = texture(u_BrushTexture, v_BrushTextureCoordinate);
  highp float alpha =  /*(1.0 - maskTexelColor.r) **/ u_Pressure;
#ifdef USES_TEXTURE
  highp vec4 textureTexelColor = texture(u_CanvasTexture, v_CanvasTextureCoordinate);
  alpha = alpha * textureTexelColor.r;
#endif
  fragmentColor = u_Color * shapeTexelColor * alpha;
}