#version 300 es

layout(location = 0) in vec4 a_Position;
layout(location = 0) uniform mat4 u_MvpMatrix;

out vec2 v_BrushTextureCoordinate;
out vec2 v_MaskTextureCoordinate;

#ifdef USES_TEXTURE
layout(location = 1) uniform float u_CanvasScale;
out vec2 v_CanvasTextureCoordinate;
#endif

void main() {
    gl_Position = u_MvpMatrix * a_Position;
    v_BrushTextureCoordinate = a_Position.xy * 0.5 + 0.5;
    v_MaskTextureCoordinate = gl_Position.xy * 0.5 + 0.5;
    #ifdef USES_TEXTURE
    v_CanvasTextureCoordinate = u_CanvasScale * v_MaskTextureCoordinate;
    #endif
}